﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Structura.Silverlight.Controls.Menu.DropDownMenu
{
	public class MenuVisualStateManager : VisualStateManager
	{
		protected override bool GoToStateCore(Control control, FrameworkElement templateRoot, string stateName, VisualStateGroup group, VisualState state, bool useTransitions)
		{
			MenuItem mi = (MenuItem)control;
			if (mi.IsEnabled == false)
			{
				//force the control to have a disabled appearence
				stateName = "Disabled";
				if (group != null)
					for (int i = 0; i < group.States.Count; i++)
						if ((group.States[i] is VisualState) && (((VisualState)(group.States[i])).Name == stateName))
							state = group.States[i] as VisualState;
			}
			if (state != null)
				return base.GoToStateCore(control, templateRoot, stateName, group, state, useTransitions);
			else
				return true;
		}
	}

	public class MenuClickEventArgs : EventArgs
	{

	}

	public delegate void MenuClickEventHandler(object sender, MenuClickEventArgs e);

	public interface IMenu
	{
		IMenu ParentMenu { get; set; }

		void CloseMenuPopup();

		bool HasSubItems { get; }
	}
}
