﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using TestApp.Silverlight.Extensions.Views;
using Structura.Infrastructure.IOC;
using TestApp.Silverlight.InvoiceModule.Controller;
using TestApp.Entities;
using Structura.Silverlight.Controls.Windows;

namespace TestApp.Silverlight.InvoiceModule.View
{
   public partial class EditInvoice : ExtendedView
   {
      public EditInvoice(IIoC ioc) :
			base(ioc)
		{
			InitializeComponent();

         Waiting.Start();
         (Controller as EditInvoiceController).Init(null);
			//we want default scrollbars for this form
         this.LayoutUpdated += new EventHandler(EditInvoice_LayoutUpdated);
		}

      public EditInvoice(IIoC ioc, Invoice invoice) :
			base(ioc)
		{
			InitializeComponent();

         Waiting.Start();
         (Controller as EditInvoiceController).Init(invoice);
			//we want default scrollbars for this form
         this.LayoutUpdated += new EventHandler(EditInvoice_LayoutUpdated);
		}

      void EditInvoice_LayoutUpdated(object sender, EventArgs e)
		{
			Window w = Parent as Window;
			w.VerticalScrollBarVisibility = ScrollBarVisibility.Auto;
			w.HorizontalScrollBarVisibility = ScrollBarVisibility.Auto;
			//let's call this method once
         this.LayoutUpdated -= EditInvoice_LayoutUpdated;
		}

		private void btnSave_Click(object sender, RoutedEventArgs e)
		{
			Waiting.Start();
         (Controller as EditInvoiceController).SaveAsync();
		}

		private void btnCancel_Click(object sender, RoutedEventArgs e)
		{
			Close();
		}

		public override void UpdateInterface()
		{
			Waiting.Stop();
		}

      private void BtnAddInvoiceItem_Click(object sender, RoutedEventArgs e)
      {
         (Controller as EditInvoiceController).AddInvoiceItem();
      }

      private void DeleteItemClick(object sender, RoutedEventArgs e)
      {
         InvoiceItem ii = ((sender as Button).Tag as InvoiceItem);
         string msg = string.Format("Are you sure you want to delete the element: {0} {1} ?", ii.Code, ii.Name);
         if (MessageBox.Show(msg, "confirm", MessageBoxButton.OKCancel) == MessageBoxResult.OK)
         {
            GridInvoiceItems.Focus();
            (Controller as EditInvoiceController).RemoveInvoiceItem(ii);
            GridInvoiceItems.InvalidateArrange();
         }
      }
   }
}
